;%%%%%%%%%%%%%%%%%%%%%%%%
;script ircII mode
;version 7.20
;author Quietust
;email quietust@ircN.org
;url http://www.ircN.org
;%%%%%%%%%%%%%%%%%%%%%%%%
on 1:JOIN:# {
  echo $colour(Join) -ti2 @ircII *** Joins $chan $+ : $nick ( $+ $address $+ )
  if ($nick == $me) {
    window -a @ircII
    set %ircIIchan $chan
  }
  if ($chan == %ircIIchan) aline -l @ircII $nick
}
on 1:RAWMODE:# { echo $colour(Mode) -ti2 @ircII *** $nick sets mode in $chan $+ : $1- | if (%ircIIchan == $chan) { ircIIupdtopic | ircIInicks } }
on 1:PART:# {
  echo $colour(Part) -ti2 @ircII *** Parts $chan $+ : $nick ( $+ $address $+ ) $paren($1-)
  if (($nick == $me) && ($chan == %ircIIchan)) {
    if ($chan(0) == 1) ircIIchan
    else ircIIchan $chan($sub($chan(0),1))
  }
  elseif ($chan == %ircIIchan) .timer 1 0 ircIInicks
}
on 1:KICK:# {
  echo $colour(Kick) -ti2 @ircII *** $pst($knick,$chan) was kicked from $chan by $nick $paren($1-)
  if ($chan == %ircIIchan) .timer 1 0 ircIInicks
  if ($knick == $me) .timer 1 0 ircIIchan $chan($sub($chan(0),1))
}
on 1:TOPIC:# { echo $colour(Topic) -ti2 @ircII *** $pst($nick,$chan) changes topic in $chan to ' $+ $1- $+ ' | if (%ircIIchan == $chan) ircIIupdtopic }
on 1:TEXT:*:# { echo -ti2 @ircII < $+ $pst($nick,$chan) $+ : $+ $chan $+ > $1- }
on 1:TEXT:*:? { echo $colour(Highlight) -ti2 @ircII * $+ $nick $+ * $1- }
on 1:NOTICE:*:# { echo $colour(Notice) -ti2 @ircII - $+ $pst($nick,$chan) $+ : $+ $chan $+ - $1- }
on 1:NOTICE:*:? { echo $colour(Notice) -ti2 @ircII - $+ $nick $+ - $1- }
on 1:ACTION:*:# { echo $colour(Action) -ti2 @ircII * $pst($nick,$chan) $+ : $+ $chan $1- }
on 1:ACTION:*:? { echo $colour(Action) -ti2 @ircII * * $+ $nick $+ * $1- }
on 1:QUIT {
  echo $colour(Quit) -ti2 @ircII *** Quits from $com.channels($nick) $+ : $nick $paren($1-)
  if ($findtok($com.channels($nick),%ircIIchan,1,44)) .timer 1 0 ircIInicks
}
on 1:NICK {
  echo $colour(Nick) -ti2 @ircII *** $nick is now known as $newnick in $com.channels($newnick)
  if ($findtok($com.channels($nick),%ircIIchan,1,44)) .timer 1 0 ircIInicks
}
on 1:CLOSE:@ircII { .timer 1 0 ircII off }
alias ircIIchk {
  if (%ircIIchan == $null) {
    iecho No ircII channel is set!
    halt
  }
}
on 1:INPUT:@ircII {
  if ($left($1,1) == /) {
    if ($1 == /me) {
      ircIIchk
      describe %ircIIchan $2-
      echo $colour(Action) -ti2 @ircII * $pst($me,%ircIIchan) $+ : $+ %ircIIchan $2-
    }
    elseif ($1 == //me) {
      ircIIchk
      .timer 1 0 describe %ircIIchan $2-
      .timer 1 0 echo $colour(Action) -ti2 @ircII * $pst($me,%ircIIchan) $+ : $+ %ircIIchan $2-
    }
    elseif (($1 == /describe) && ($2 ischan)) {
      ircIIchan $2
      describe %ircIIchan $3-
      echo $colour(Action) -ti2 @ircII * $pst($me,%ircIIchan) $+ : $+ %ircIIchan $3-
    }
    elseif (($1 == //describe) && ($2 ischan)) {
      ircIIchan $2
      .timer 1 0 describe %ircIIchan $3-
      .timer 1 0 echo $colour(Action) -ti2 @ircII * $pst($me,%ircIIchan) $+ : $+ %ircIIchan $3-
    }
    elseif (($1 == /msg) && ($2 ischan)) {
      ircIIchan $2
      msg %ircIIchan $3-
      echo -ti2 @ircII < $+ $pst($me,%ircIIchan) $+ : $+ %ircIIchan $+ > $3-
    }
    elseif (($1 == //msg) && ($2 ischan)) {
      ircIIchan $2
      .timer 1 0 msg %ircIIchan $3- 
      .timer 1 0 echo -ti2 @ircII < $+ $pst($me,%ircIIchan) $+ : $+ %ircIIchan $+ > $3-
    }
    else return
  }
  elseif ((%nc == on) && ($right($1,1) == %nch) && ($len($1) > 1) && ($chr(44) !isin $getleft($1)) && ($chr(40) !isin $getleft($1)) && ($chr(41) !isin $getleft($1))) {
    ircIIchk
    if ($nc($1,%ircIIchan)) say $ncomp($nc($1,%ircIIchan)) $2-
    else say $1-
  }
  else {
    ircIIchk
    say $1-
  }
  halt
}
alias ircIIchan {
  set %ircIIchan $1
  if ($1 == $null) {
    clear -l @ircII
    titlebar @ircII - No channel selected
  }
  ircIIupdtopic
  ircIInicks
}
alias ircIInicks {
  clear -l @ircII
  set %itmp.n 0
  :start
  inc %itmp.n
  if ($opnick(%ircIIchan,%itmp.n)) {
    aline -l @ircII @ $+ $opnick(%ircIIchan,%itmp.n)
    goto start
  }  
  set %itmp.n 0
  :start2
  inc %itmp.n
  if ($vnick(%ircIIchan,%itmp.n)) {
    aline -l @ircII + $+ $vnick(%ircIIchan,%itmp.n)
    goto start2
  }  
  set %itmp.n 0
  :start3
  inc %itmp.n
  if ($rnick(%ircIIchan,%itmp.n)) {
    aline -l @ircII $rnick(%ircIIchan,%itmp.n)
    goto start3
  }  
}
alias ircIIupdtopic {
  if (($chan(%ircIIchan).topic) && ($chan(%ircIIchan).mode)) titlebar @ircII %ircIIchan $ab($chan(%ircIIchan).mode) $+ : $chan(%ircIIchan).topic
  elseif ($chan(%ircIIchan).mode) titlebar @ircII %ircIIchan $ab($chan(%ircIIchan).mode)
  elseif ($chan(%ircIIchan).topic) titlebar @ircII %ircIIchan $+ : $chan(%ircIIchan).topic
  else titlebar @ircII %ircIIchan
}
raw 324:* {
  if ($2 == %ircIIchan) ircIIupdtopic
}
raw 332:* {
  if ($2 == %ircIIchan) ircIIupdtopic
}
raw 366:* {
  if ($2 == %ircIIchan) ircIInicks $2
}
