;%%%%%%%%%%%%%%%%%%%%%%%%
;script iTelnet
;version 7.0
;author Quietust
;email quietust@ircN.org
;url http://www.ircN.org
;%%%%%%%%%%%%%%%%%%%%%%%%
on 1:SOCKOPEN:iTelnet.* {
  window -ake @ $+ $sockname %teloc @telnet Courier New 
  clear @ $+ $sockname
  if ($sockerr > 0) { echo @ $+ $sockname *** Connection Error ( $+ $sockerr $+ ) | halt }
  echo @ $+ $sockname *** Connection Accepted
  titlebar @ $+ $sockname - $sock($sockname).ip ( $+ $sock($sockname).port $+ )
  sockmark $sockname %def.tel.echo
  echo @ $+ $sockname Local echo is $upper(%def.tel.echo) $+ . Use popups to toggle.
}
on 1:SOCKCLOSE:iTelnet.* {
  echo @ $+ $sockname *** Connection Terminated
  titlebar @ $+ $sockname -- Not connected
}
on 1:SOCKREAD:iTelnet.* {
  if ($sockerr > 0) { iecho Error occured while iTelnet session $gettok($sockname,2,46) was connected! ( $+ $sockerr $+ ) | halt }
  :nextread
  sockread %iTelnet.tmp
  if ($sockbr == 0) return
  set %iTelnet.tmp $replace(%iTelnet.tmp,$chr(32),)
  if (%iTelnet.tmp) echo @ $+ $sockname %iTelnet.tmp
  else echo @ $+ $sockname 
  goto nextread
}
on 1:INPUT:@iTelnet.* {
  if ($left($1,1) == /) return
  if ($1 != $null) {
    sockwrite -n $getright($active) $1-
    if ($sock($getright($active)).mark == on) echo -a $1-
  }
  halt
}
on 1:CLOSE:@iTelnet.* {
  set %teloc $swlc($target)
  sockclose $getright($target)
  unset %iTelnet. [ $+ [ $gettok($target,2,46) ] $+ ] .*
  iecho iTelnet session $gettok($target,2,46) closed.
}
menu @telnet {
  exit {
    sockclose $remove($window($active),@)
    unset %iTelnet. [ $+ [ $gettok($window($active),2,46) ] $+ ] .*
    iecho iTelnet session $gettok($window($active),2,46) closed.
    window -c $window($active)
  }
  -
  egg
  .send nick { sockwrite -n $getright($active) $me }
  .whom { sockwrite -n $getright($active) .whom }
  .who { sockwrite -n $getright($active) .who }
  .whois { sockwrite -n $getright($active) .whois $$?="enter nick to whois:" }
  .help { sockwrite -n $getright($active) .help }
  .echo
  ..remote { sockmark $getright($active) off | sockwrite -n $getright($active) .echo on }
  ..local { sockmark $getright($active) on | sockwrite -n $getright($active) .echo off }
  -
  echo
  .on { sockmark $getright($active) on }
  .off { sockmark $getright($active) off }
}
