;%%%%%%%%%%%%%%%%%%%%%%%%
;script ircN User Central
;version 7.20
;author Quietust, Sarek
;email quietust@ircN.org
;url http://www.ircN.org
;%%%%%%%%%%%%%%%%%%%%%%%%
dialog ircN.ucentral {
  title "ircN Userlist Central"
  option dbu
  size -1 -1 214 222
  button "&Close", 1, 161 200 32 12, cancel
  button "&Stats + Close", 2, 101 200 48 12
  box "", 10, 4 4 76 36
  text "User:", 11, 8 13 12 8, right
  combo  12, 22 12 54 64, drop edit sort
  button "Create", 13, 8 26 20 10
  button "Edit", 14, 32 26 20 10
  button "Delete", 15, 56 26 20 10
  box "Flags", 20, 84 4 126 138
  radio "Global Flags", 21, 92 12 38 8, group
  radio "Channel Flags", 22, 152 12 44 8
  text "Channel:", 23, 88 23 22 8
  combo 24, 112 22 44 64, drop edit
  button "Add", 25, 160 22 16 10
  button "Remove", 26, 180 22 26 10
  check "+a: Auto-Op", 27, 92 34 54 8
  check "+b: Bot", 28, 92 44 54 8
  check "+c: Accept Chats", 29, 92 54 54 8
  check "+d: Auto-Deop", 30, 92 64 54 8
  check "+f: Protect", 31, 92 74 54 8
  check "+g: Get Ops", 32, 92 84 54 8
  check "+i: ircN 7 bot", 33, 92 94 54 8
  check "+j: File Area Janitor", 34, 92 104 54 8
  check "+k: Auto-Kick", 35, 92 114 54 8
  check "+m: Master", 36, 152 34 54 8
  check "+n: Owner", 37, 152 44 54 8
  check "+o: Op", 38, 152 54 54 8
  check "+p: Partyline", 39, 152 64 54 8
  check "+r: Remote Control", 40, 152 74 54 8
  check "+s: Accept Sends", 41, 152 84 54 8
  check "+v: Auto-Voice", 42, 152 94 54 8
  check "+x: File Area", 43, 152 104 54 8
  text "Other:", 44, 152 115 16 8
  edit "", 45, 170 114 36 11, autohs
  button "Update Flags", 46, 152 128 54 10
  box "Hostmasks", 50, 4 42 76 36
  combo 51, 8 50 68 64, drop edit
  button "Add", 52, 8 64 32 10
  button "Remove", 53, 44 64 32 10
  box "Passwords", 60, 4 80 76 62
  text "User Password:", 61, 8 89 38 8
  edit "", 62, 48 88 28 11, autohs pass
  button "Update User Password", 63, 8 102 68 10
  text "Bot Password:", 64, 8 115 38 8
  edit "", 65, 48 114 28 11, autohs pass
  button "Update Bot Password", 66, 8 128 68 10
  box "Info-Lines", 70, 4 144 76 72
  radio "Global", 71, 8 152 26 8, group
  radio "Channel", 72, 44 152 30 8
  text "Channel:", 73, 8 163 22 8
  combo 74, 32 162 44 64, drop edit
  button "Add", 75, 8 176 32 10
  button "Remove", 76, 44 176 32 10
  text "Infoline:", 77, 8 189 20 8
  edit "", 78, 32 188 44 11, autohs
  button "Update Info-line", 79, 32 202 44 10
  box "", 80, 84 144 126 72
  text "", 81, 88 152 118 46, center
}
on 1:DIALOG:ircN.ucentral:*:* {
  if ($devent == init) {
    did -a $dname 81 Userlist Central for ircN 7.20 + mIRC 5.7 $+ $crlf $+ Dialog written by The Quietust $+ $crlf $+ Dialog handler written by Sarek $+ $crlf $+ $crlf $+ Send suggestions or comments $+ $crlf $+ to quietust@ircN.org
    did -b $dname 13,14,15,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,51,52,53,61,62,63,64,65,66,71,72,73,74,75,76,77,78,79
    if ($script(usersum.mrc) == $null) did -b $dname 2
    ucentral.getusers
  }
  elseif ($devent == sclick) {
    if ($did == 2) {
      dialog -x $dname
      usersum
    }
    elseif (($did == 12) && ($did(12,$did(12).sel) != $null)) { 
      did -b $dname 13
      did -e $dname 14,15
      did -br $dname 51
    }
    elseif ($did == 13) {
      .adduser $did(12) $did(51)
      did -a $dname 12 $did(12)
      ucentral.usercheck
    }
    elseif (($did == 14) && ($did(14).text == Edit)) {
      did -b $dname 12,13,15,74,75,76
      did -ra $dname 14 Exit
      did -c $dname 21,71
      did -e $dname 21,22,23,44,45,51,61,62,64,65,71,72,73,77,78
      ucentral.updatechannels
      if ($flags($did(12)) != $chr(45)) did -ra $dname 45 $flags($did(12))
      ucentral.updateflags
      ucentral.updatehosts
      did -ra $dname 62 $password($did(12))
      did -ra $dname 65 $botpass($did(12))
      did -ra $dname 78 $infoline($did(12))
    }
    elseif (($did == 14) && ($did(14).text == Exit)) {
      did -ra $dname 14 Edit
      did -b $dname 13,14,15,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,51,52,53,62,63,65,66,71,72,74,75,76,78,79
      did -u $dname 21,22,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,71,72
      did -r $dname 24,45,51,62,65
      did -e $dname 12
      ucentral.usercheck
    }
    elseif ($did == 15) {
      .remuser $did(12)
      ucentral.getusers
      ucentral.usercheck
    }
    elseif ($did == 21) {
      did -r $dname 45
      did -e $dname 44,45
      did -b $dname 24,25,26,46
      did -u $dname 27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43
      if ($did(72).state) did -b $dname 78
      if ($flags($did(12)) != $chr(45)) did -ra $dname 45 $flags($did(12))
      else did -r $dname 45
      ucentral.updateflags
      ucentral.updatechannels
    }
    elseif ($did == 22) { 
      did -e $dname 24
      did -b $dname 25,26,44,45,46
      did -u $dname 27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43
      if ($did(72).state) did -b $dname 78
      did -bu $dname 27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43
      ucentral.updatechannels
      did -r $dname 45
    }
    elseif (($did == 24) && ($did(24,$did(24).sel) != $null)) {
      did -e $dname 26,44,45
      did -b $dname 25
      if ($cflags($did(12),$did(24,$did(24).sel)) != $chr(45)) did -ra $dname 45 $ifmatch
      else did -r $dname 45
      ucentral.updateflags
    }
    elseif ($did == 25) {
      .addchan $did(12) $did(24).text
      ucentral.updatechannels
      did -bu $dname 27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43
      did -b $dname 25,26,44,45,46
    }
    elseif ($did == 26) { 
      .remchan $did(12) $did(24).text
      ucentral.updatechannels
      did -bu $dname 27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43
      did -b $dname 25,26,44,45,46
    }
    elseif ((27 <= $did) && ($did <= 43)) did -e $dname 46
    elseif ($did == 46) {
      var %a, %z
      did -b $dname 46
      set %a 1
      while ($mid(abcdfgijkmnoprsvx,%a,1) != $null) {
        set %z $ifmatch
        if ($did($pls(%a,26)).state) did -a $dname 45 %z
        inc %a
      }
      .chattr $did(12) $did(45) $did(24).text
      ucentral.updateflags
    }
    elseif ($did == 51) did -e $dname 53
    elseif ($did == 52) {
      if ($did(51).text) {
        .addhost $did(12) $did(51).text 
        ucentral.updatehosts
      }
    }
    elseif ($did == 53) {
      .remhost $did(12) $did(51).text
      ucentral.updatehosts
    }
    elseif ($did == 63) {
      .chpass $did(12) $did(62).text
      did -b $dname 63
    }
    elseif ($did == 66) {
      .chbotpass $did(12) $did(65).text
      did -b $dname 66
    }
    elseif ($did == 71) {
      did -b $dname 74,75,76,79
      if ($did(22).state) did -ub $dname 25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46
      did -rae $dname 78 $infoline($did(12))
      ucentral.updatechannels
    }
    elseif ($did == 72) {
      did -r $dname 78
      did -b $dname 78,79
      if ($did(22).state) did -ub $dname 25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46
      ucentral.updatechannels
      did -e $dname 74
    }
    if (($did == 74) && ($did(74,$did(74).sel) != $null)) {
      did -e $dname 76
      did -b $dname 75,79
      did -era $dname 78 $infoline($did(12),$did(74,$did(74).sel))
    }
    elseif ($did == 75) { 
      .addchan $did(12) $did(74).text
      ucentral.updatechannels
      did -r $dname 78
      did -b $dname 78,79
    }
    elseif ($did == 76) { 
      .remchan $did(12) $did(74,$did(74).sel).text
      did -r $dname 78
      did -b $dname 78,79
      ucentral.updatechannels
    }
    elseif ($did == 79) {
      .chinfo $did(12) $did(74).text $iif($did(78).text,$did(78).text,none)
      did -b $dname 79
    }
  }
  elseif ($devent == edit) {
    if ($did == 12) ucentral.usercheck
    elseif ($did == 24) {
      did -bu $dname 27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43
      did -b $dname 46
      if (($did(24) != $null) && ($#($did(24)) == $did(24))) {
        if ($cflags($did(12),$did(24)) != $null) {
          did -e $dname 26,44,45
          did -b $dname 25
          if ($cflags($did(12),$did(24)) != $chr(45)) did -ra $dname 45 $ifmatch
          else did -r $dname 45
          ucentral.updateflags
        }
        else {
          did -e $dname 25
          did -b $dname 26,44,45
        }
      }
      else did -b $dname 25,26,44,45,46
    }
    elseif ($did == 45) {
      did -e $dname 46
      ucentral.updateflags
    }
    elseif ($did == 51) {
      if ($did(14) == Edit) ucentral.usercheck
      else {
        if ((*!*@* iswm $did(51)) && ($ulist($did(51),40,0) == 0)) did -e $dname 52
        else did -b $dname 52
        var %a, %b, %z
        set %z $usrhost($did(12))
        set %a 1
        while ($gettok(%z,%a,32) != $null) {
          if ($gettok(%z,%a,32) == $did(51)) set %b $true
          inc %a
        }
        if (%b) did -e $dname 53
        else did -b $dname 53
      }
    }
    elseif ($did == 62) did -e $dname 63
    elseif ($did == 65) did -e $dname 66
    elseif ($did == 74) {
      did -r $dname 78
      did -b $dname 79
      if (($did(74) != $null) && ($#($did(74)) == $did(74))) {
        if ($cflags($did(12),$did(74)) != $null) {
          did -e $dname 76,78
          did -b $dname 75
        }
        else { 
          did -e $dname 75
          did -b $dname 76,78
        }
      }
      else did -b $dname 75,76,78
    }
    elseif ($did == 78) did -e $dname 79
  }
}
alias ucentral dialog -m ircN.ucentral ircN.ucentral
alias -l # return #$1
alias -l ucentral.getusers {
  unset %_ucentral.name.*
  did -r $dname 12
  var %a, %z
  set %a 1
  while ($ulist(*,40,%a)) {
    set %z $usrh($ifmatch)
    if (%_ucentral.name. [ $+ [ %z ] ] == $null) {
      set %_ucentral.name. [ $+ [ %z ] ] 1
      did -a $dname 12 %z
    }
    inc %a
  }
  unset %_ucentral.name.*
}
alias -l ucentral.usercheck {
  if ($did(12) != $null) {
    if ($usrhost($did(12)) != $null) {
      did -b $dname 13
      did -e $dname 14,15
      did -br $dname 51
    }
    else {
      did -b $dname 14,15
      did -e $dname 51
      if ((*!*@* iswm $did(51)) && ($ulist($did(51),40,0) == 0)) did -e $dname 13
      else did -b $dname 13
    }
  }
  else did -b $dname 13,14,15,51
}
alias -l ucentral.updatechannels {
  var %a, %z
  did -r $dname 24,74
  if ($usrchans($did(12)) != $null) {
    set %z $ifmatch
    set %a 1
    while ($gettok(%z,%a,44) != $null) {
      did -a $dname 24,74 $ifmatch
      inc %a
    }
  }
  did -b $dname 25,26,75,76
}
alias -l ucentral.updateflags {
  var %a, %z
  set %a 1
  while ($mid(abcdfgijkmnoprsvxehlqtuwyz,%a,1) != $null) {
    set %z $ifmatch
    if (((%z isincs abcdfgijkmnoprsvx) && ($did(21).state)) || (%z isincs adfgkov)) did -e $dname $pls(%a,26)
    if (%z isincs $did(45)) {
      if (((%z isincs abcdfgijkmnoprsvx) && ($did(21).state)) || (%z isincs adfgkov)) did -c $dname $pls(%a,26)
      did -ra $dname 45 $removecs($did(45),%z)
    }
    inc %a
  }
}
alias -l ucentral.updatehosts {
  var %a, %z
  did -b $dname 52,53
  did -r $dname 51
  set %z $usrhost($did(12))
  set %a 1
  while ($gettok(%z,%a,32) != $null) {
    did -a $dname 51 $ifmatch
    inc %a
  }
}
